/**
 * ASBlock.java
 * 
 * Copyright (c) 2006 David Holroyd
 */

package uk.co.badgersinfoil.metaas.dom;

import uk.co.badgersinfoil.metaas.ActionScriptFactory;

/**
 * A code-block, as used for a while-loop body or if-statement branch.
 *  
 * @see ActionScriptFactory#newBlock()
 */
public interface ASBlock extends Statement, StatementContainer {
	// An implementation of StatementContainer (e.g. an ASMethod) will not
	// be an appropriate value for things like a loop body.  Hence this
	// interface exists to differentiate those StatementContainer
	// implementations which are actually blocks; even though it doesn't
	// define any methods.
}
