/**
 * CompilationUnit.java
 * 
 * Copyright (c) 2006 David Holroyd
 */

package uk.co.badgersinfoil.metaas.dom;

/**
 * A 'compilation unit' represents an entire file of ActionScript code.
 * 
 * @see uk.co.badgersinfoil.metaas.ActionScriptProject#newClass(String)
 * @see uk.co.badgersinfoil.metaas.ActionScriptProject#newInterface(String)
 */
public interface ASCompilationUnit {
	/**
	 * Returns the name of the package, or null if the contents of the file
	 * are in the 'default' (top-level) package.
	 */
	public String getPackageName();

	/**
	 * Returns the type ({@link ASClassType} or {@link ASInterfaceType})
	 * which this file defines.
	 */
	public ASType getType();

	/**
	 * Modifies the name of the package containing the code of this
	 * compilation-unit.  Passing null causes the resulting code to be in
	 * the 'default' (top-level) package.
	 */
	public void setPackageName(String name);

	/**
	 * Returns the first ActionScript package-block declaired in this
	 * compilation-unit.
	 */
	public ASPackage getPackage();
}