/**
 * ASDeclarationStatement.java
 * 
 * Copyright (c) 2006-2007 David Holroyd
 */

package uk.co.badgersinfoil.metaas.dom;

/**
 * Represents a statement that declares a variable.
 */
public interface ASDeclarationStatement extends Statement {

	/**
	 * Returns false if this is a declaration using the <code>var</code>
	 * keyword (the default), and true is this is a declaration using the
	 * <code>const</code> keyword.
	 */
	public boolean isConstant();

	/**
	 * If given true, this declaration will use the <code>const</code>
	 * keyword, if given false, this declaration will use the
	 * <code>var</code> keyword.
	 */
	public void setContant(boolean constant);
}