/**
 * ASInterfaceType.java
 * 
 * Copyright (c) 2006 David Holroyd
 */

package uk.co.badgersinfoil.metaas.dom;

import java.util.List;

/**
 * A handle on the definition of an ActionScript interface.
 * 
 * @see uk.co.badgersinfoil.metaas.ActionScriptFactory#newInterface(String)
 */
public interface ASInterfaceType extends ASType {

	/**
	 * Returns a list of Strings which are the names of ActionScript
	 * interfaces which this ActionScript interface extends.
	 */
	public List getSuperInterfaces();

	/**
	 * Adds the given ActionScript interface name to the list of interfaces
	 * which this ActionScript interface extends.
	 */
	public void addSuperInterface(String interfaceName);

	/**
	 * Removes the given ActionScript interface name from the list of
	 * interfaces which this ActionScript interface extends.
	 */
	public void removeSuperInterface(String interfaceName);
}
