/**
 * ASSwitchCase.java
 * 
 * Copyright (c) 2007 David Holroyd
 */

package uk.co.badgersinfoil.metaas.dom;

/**
 * Obtained from {@link ASSwitchStatement#newCase(String)}, ASSwitchCase
 * represents a switch-statement case-label, and the list of statements
 * immediately following it.
 * 
 * @see ASSwitchStatement
 */
public interface ASSwitchCase extends StatementContainer {

	/**
	 * Returns a string representation of the value expression for this
	 * label.  e.g. given the label <code>case 42:</code>, this method
	 * would return the string <code>"42"</code>.
	 */
	public String getLabelValueString();

	/**
	 * Changes the value expression for this case label.
	 * 
	 * @throws uk.co.badgersinfoil.metaas.SyntaxException if the given
	 * string is not a valid ActionScript expression.
	 */
	public void setLabelValue(String constant);
}