/**
 * ASWhileStatement.java
 * 
 * Copyright (c) 2007 David Holroyd
 */

package uk.co.badgersinfoil.metaas.dom;


/**
 * Obtained from {@link StatementContainer#newWhile(String)}, this represents
 * a <code>while (test()) { }</code> construct.
 * 
 * <p>e.g. The Java code,</p>
 * <pre class="eg">ASWhileStatement whileStmt = method.newWhile("test()");
 *whileStmt.addStmt("trace('hello')");</pre>
 */
public interface ASWhileStatement extends Statement, StatementContainer {

	public String getConditionString();
	public void setCondition(String string);
}
