/**
 * AS3ASTCompilationUnit.java
 * 
 * Copyright (c) 2006 David Holroyd
 */

package uk.co.badgersinfoil.metaas.impl;

import org.asdt.core.internal.antlr.AS3Parser;

import uk.co.badgersinfoil.metaas.dom.ASPackage;
import uk.co.badgersinfoil.metaas.dom.ASType;
import uk.co.badgersinfoil.metaas.impl.antlr.LinkedListTree;


public class AS3ASTCompilationUnit extends ASTASCompilationUnit {

	public AS3ASTCompilationUnit(LinkedListTree ast) {
		super(ast);
	}

	public String getPackageName() {
		return getPackage().getName();
	}

	public void setPackageName(String pkgName) {
		getPackage().setName(pkgName);
	}

	public ASType getType() {
		ASPackage pkg = getPackage();
		if (pkg == null) {
			return null;
		}
		return pkg.getType();
	}
	
	private LinkedListTree getPkgNode() {
		return ASTUtils.findChildByType(ast, AS3Parser.PACKAGE);
	}

	public ASPackage getPackage() {
		LinkedListTree pkg = getPkgNode();
		if (pkg == null) {
			return null;
		}
		return new ASTASPackage(pkg);
	}
}