/**
 * ASTASDoWhileStatement.java
 * 
 * Copyright (c) 2007 David Holroyd
 */

package uk.co.badgersinfoil.metaas.impl;

import org.asdt.core.internal.antlr.AS3Parser;
import uk.co.badgersinfoil.metaas.dom.ASDoWhileStatement;
import uk.co.badgersinfoil.metaas.dom.StatementContainer;
import uk.co.badgersinfoil.metaas.impl.antlr.LinkedListTree;


public class ASTASDoWhileStatement extends ContainerDelegate implements ASDoWhileStatement {

	private static final int INDEX_STATEMENT = 0;
	private static final int INDEX_CONDITION = 1;
	private LinkedListTree ast;

	public ASTASDoWhileStatement(LinkedListTree ast) {
		ASTUtils.assertAS3TokenTypeIs(AS3Parser.DO, ast.getType());
		this.ast = ast;
	}

	private LinkedListTree getChild(int index) {
		return (LinkedListTree)ast.getChild(index);
	}
	protected StatementContainer getStatementContainer() {
		return new ASTStatementList(getChild(INDEX_STATEMENT));
	}

	public String getConditionString() {
		return ASTUtils.stringifyNode(getChild(INDEX_CONDITION).getFirstChild());
	}

	public void setCondition(String expr) {
		LinkedListTree cond = AS3FragmentParser.parseCondition(expr);
		ast.setChildWithTokens(INDEX_CONDITION, cond);
	}
}
