/**
 * ASTASReturnStatement.java
 * 
 * Copyright (c) 2007 David Holroyd
 */

package uk.co.badgersinfoil.metaas.impl;

import uk.co.badgersinfoil.metaas.dom.ASReturnStatement;
import uk.co.badgersinfoil.metaas.impl.antlr.LinkedListToken;
import uk.co.badgersinfoil.metaas.impl.antlr.LinkedListTree;


public class ASTASReturnStatement implements ASReturnStatement {

	private LinkedListTree ast;

	public ASTASReturnStatement(LinkedListTree ast) {
		this.ast = ast;
	}

	public String getExpressionString() {
		if (ast.getChildCount() == 0) {
			return null;
		}
		return ASTUtils.stringifyNode(ast.getFirstChild());
	}

	public void setExpression(String expr) {
		if (expr == null) {
			if (ast.getChildCount() == 0) {
				return;
			}
			ast.deleteChild(0);
			return;
		}
		LinkedListTree expression = AS3FragmentParser.parseExpr(expr);
		if (ast.getChildCount() == 0) {
			LinkedListToken after = ast.getStopToken();
			LinkedListToken before = after.getPrev();
			ast.addChild(expression);
			before.setNext(expression.getStartToken());
			after.setPrev(expression.getStopToken());
		} else {
			ast.setChildWithTokens(0, expression);
		}
	}
}