/**
 * ASTASSwitchStatement.java
 * 
 * Copyright (c) 2007 David Holroyd
 */

package uk.co.badgersinfoil.metaas.impl;

import uk.co.badgersinfoil.metaas.dom.ASSwitchCase;
import uk.co.badgersinfoil.metaas.dom.StatementContainer;
import uk.co.badgersinfoil.metaas.impl.antlr.LinkedListTree;

public class ASTASSwitchCase extends ContainerDelegate implements ASSwitchCase {

	private static final int INDEX_LABELVAL = 0;
	private static final int INDEX_CONTAINER = 1;
	private LinkedListTree ast;

	public ASTASSwitchCase(LinkedListTree ast) {
		this.ast = ast;
	}

	public String getLabelValueString() {
		return ASTUtils.stringifyNode(getChild(INDEX_LABELVAL));
	}

	public void setLabelValue(String constant) {
		LinkedListTree label = AS3FragmentParser.parseExpr(constant);
		ast.setChildWithTokens(INDEX_LABELVAL, label);
	}

	private LinkedListTree getChild(int index) {
		return (LinkedListTree)ast.getChild(index);
	}
	protected StatementContainer getStatementContainer() {
		return new ASTStatementList(getChild(INDEX_CONTAINER));
	}

}