/**
 * ASTASSwitchStatement.java
 * 
 * Copyright (c) 2006-2007 David Holroyd
 */

package uk.co.badgersinfoil.metaas.impl;

import org.asdt.core.internal.antlr.AS3Parser;
import uk.co.badgersinfoil.metaas.dom.ASSwitchCase;
import uk.co.badgersinfoil.metaas.dom.ASSwitchDefault;
import uk.co.badgersinfoil.metaas.dom.ASSwitchStatement;
import uk.co.badgersinfoil.metaas.impl.antlr.LinkedListTree;

// TODO: add access to the 'switch condition'

public class ASTASSwitchStatement implements ASSwitchStatement {

	private LinkedListTree ast;

	public ASTASSwitchStatement(LinkedListTree block) {
		ast = block;
	}

	public ASSwitchCase newCase(String expr) {
		LinkedListTree caseStmt = ASTUtils.newAST(AS3Parser.CASE, "case");
		caseStmt.appendToken(TokenBuilder.newSpace());
		caseStmt.addChildWithTokens(AS3FragmentParser.parseExpr(expr));
		caseStmt.appendToken(TokenBuilder.newColon());
		LinkedListTree stmtList = ASTUtils.newImaginaryAST(AS3Parser.SWITCH_STATEMENT_LIST);
		caseStmt.addChildWithTokens(stmtList);
		ASTUtils.addChildWithIndentation(ast, caseStmt);
		return new ASTASSwitchCase(caseStmt);
	}

	public ASSwitchDefault newDefault() {
		LinkedListTree defaultStmt = ASTUtils.newAST(AS3Parser.DEFAULT, "default");
		defaultStmt.appendToken(TokenBuilder.newColon());
		LinkedListTree stmtList = ASTUtils.newImaginaryAST(AS3Parser.SWITCH_STATEMENT_LIST);
		defaultStmt.addChildWithTokens(stmtList);
		ASTUtils.addChildWithIndentation(ast, defaultStmt);
		return new ASTASSwitchDefault(defaultStmt);
	}
}