/**
 * ASTASWhileStatement.java
 * 
 * Copyright (c) 2007 David Holroyd
 */

package uk.co.badgersinfoil.metaas.impl;

import org.asdt.core.internal.antlr.AS3Parser;
import uk.co.badgersinfoil.metaas.dom.ASWhileStatement;
import uk.co.badgersinfoil.metaas.dom.StatementContainer;
import uk.co.badgersinfoil.metaas.impl.antlr.LinkedListTree;


public class ASTASWhileStatement extends ContainerDelegate implements ASWhileStatement {

	private static final int INDEX_CONDITION = 0;
	private static final int INDEX_STATEMENT = 1;
	private LinkedListTree ast;

	public ASTASWhileStatement(LinkedListTree ast) {
		ASTUtils.assertAS3TokenTypeIs(AS3Parser.WHILE, ast.getType());
		this.ast = ast;
	}

	private LinkedListTree getChild(int index) {
		return (LinkedListTree)ast.getChild(index);
	}
	protected StatementContainer getStatementContainer() {
		return new ASTStatementList(getChild(INDEX_STATEMENT));
	}

	public String getConditionString() {
		return ASTUtils.stringifyNode(ast.getFirstChild().getFirstChild());
	}

	public void setCondition(String expr) {
		LinkedListTree cond = AS3FragmentParser.parseCondition(expr);
		ast.setChildWithTokens(INDEX_CONDITION, cond);
	}
}
