package uk.co.badgersinfoil.metaas.impl;

import uk.co.badgersinfoil.metaas.dom.ASWithStatement;
import uk.co.badgersinfoil.metaas.dom.StatementContainer;
import uk.co.badgersinfoil.metaas.impl.antlr.LinkedListTree;

public class ASTASWithStatement extends ContainerDelegate implements ASWithStatement {

	private static final int INDEX_CONDITION = 0;
	private LinkedListTree ast;

	public ASTASWithStatement(LinkedListTree ast) {
		this.ast = ast;
	}

	protected StatementContainer getStatementContainer() {
		return new ASTStatementList(ast.getLastChild());
	}

	public String getConditionString() {
		return ASTUtils.stringifyNode(ast.getFirstChild().getFirstChild());
	}

	public void setCondition(String expr) {
		LinkedListTree cond = AS3FragmentParser.parseCondition(expr);
		ast.setChildWithTokens(INDEX_CONDITION, cond);
	}
}