package uk.co.badgersinfoil.metaas.impl;

import java.util.List;
import uk.co.badgersinfoil.metaas.dom.ASDeclarationStatement;
import uk.co.badgersinfoil.metaas.dom.ASDoWhileStatement;
import uk.co.badgersinfoil.metaas.dom.ASExpressionStatement;
import uk.co.badgersinfoil.metaas.dom.ASForEachInStatement;
import uk.co.badgersinfoil.metaas.dom.ASForInStatement;
import uk.co.badgersinfoil.metaas.dom.ASForStatement;
import uk.co.badgersinfoil.metaas.dom.ASIfStatement;
import uk.co.badgersinfoil.metaas.dom.ASReturnStatement;
import uk.co.badgersinfoil.metaas.dom.ASSwitchStatement;
import uk.co.badgersinfoil.metaas.dom.ASWhileStatement;
import uk.co.badgersinfoil.metaas.dom.ASWithStatement;
import uk.co.badgersinfoil.metaas.dom.StatementContainer;

public abstract class ContainerDelegate implements StatementContainer {

	protected abstract StatementContainer getStatementContainer();

	public void addStmt(String statement) {
		getStatementContainer().addStmt(statement);
	}

	public ASExpressionStatement newExprStmt(String expr) {
		return getStatementContainer().newExprStmt(expr);
	}

	public void addComment(String text) {
		getStatementContainer().addComment(text);
	}

	public ASIfStatement newIf(String condition) {
		return getStatementContainer().newIf(condition);
	}

	public ASForStatement newFor(String init, String condition,	String update) {
		return getStatementContainer().newFor(init, condition, update);
	}

	public ASForInStatement newForIn(String init, String list) {
		return getStatementContainer().newForIn(init, list);
	}

	public ASForEachInStatement newForEachIn(String init, String list) {
		return getStatementContainer().newForEachIn(init, list);
	}

	public ASWhileStatement newWhile(String condition) {
		return getStatementContainer().newWhile(condition);
	}

	public ASDoWhileStatement newDoWhile(String condition) {
		return getStatementContainer().newDoWhile(condition);
	}

	public ASSwitchStatement newSwitch(String condition) {
		return getStatementContainer().newSwitch(condition);
	}

	public ASWithStatement newWith(String expr) {
		return getStatementContainer().newWith(expr);
	}

	public ASDeclarationStatement newDeclaration(String assignment) {
		return getStatementContainer().newDeclaration(assignment);
	}

	public ASReturnStatement newReturn(String expr) {
		return getStatementContainer().newReturn(expr);
	}

	public boolean containsCode() {
		return getStatementContainer().containsCode();
	}
	
	public List getStatementList() {
		return getStatementContainer().getStatementList();
	}
}